from typing import Dict
from Vertex import Vertex
import collections


def change_period(filename):

    period = 20
    outputname = "tmp.txt"

    with open(filename) as f:
        content = f.readlines()
    content = [line.rstrip('\n') for line in content]

    f = open(outputname, "w+")


    curr_timestamp = -1
    last_t = 0

    length = len(content)
    line_num = 0

    while line_num < length:
        line = content[line_num]
        contents = line.split()


        if len(contents) > 2:

            t, u, v = int(contents[0]), int(contents[1]), int(contents[2])

            if curr_timestamp == -1:
                curr_timestamp = 0
                last_t = t
            elif t != last_t:
                if last_t + period < t:
                    curr_timestamp += 1
                    f.write(str(curr_timestamp) + " " + str(-1) + " " + str(-2) + "\n")
                curr_timestamp += 1
                last_t = t
            f.write(str(curr_timestamp) + " " + str(u) + " " + str(v) + "\n")

        line_num += 1

    f.close()




def print_clique(clique):
    # type: (collections.OrderedDict[int, Vertex]) -> None

    print("{", end='')
    for vertex in clique.values():
        x = vertex
        print(str(x.name), end='')
        break
    for vertex in clique.values():
        if vertex.name != x.name:
            print(", " + str(vertex.name), end='')
    print("}", end='\n')

def print_clique_by_id(clique):
    # type: (collections.OrderedDict[int, Vertex]) -> None

    print("{", end='')
    for vertex in clique.values():
        x = vertex
        print(str(x.id), end='')
        break
    for vertex in clique.values():
        if vertex.id != x.id:
            print(", " + str(vertex.id), end='')
    print("}", end='\n')




def print_cliques(cliques):
    # type: (List[collections.OrderedDict[int, Vertex]]) -> None

    for clique in cliques:
        print_clique(clique)



def print_input(file, delta, c, algorithm):
    # type; (str, int, int, int) -> None

    print("Filename: " + str(file))
    print("Delta:    " + str(delta))
    print("c:        " + str(c))
    print("algo:     " + str(algorithm))
